package set1

const AlphabeticCharacters = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

const AlphabeticCharactersByFrequency = "zjqxkvbpgwyfmculdhrsnioate"

const SomeShakespeare = "That can I, At least, the whisper goes so: our last king, Whose image even but now appeared to us, Was, as you know, by Fortinbras of Norway, Thereto pricked on by a most emulate pride, Dared to the combat, in which our valiant Hamlet - For so this side of our known world esteemed him - Did slay this Fortinbras, who by a sealed compact, Well ratified by law and heraldry, Did forfeit, with his life, all those his lands Which he stood seized on to the conqueror: Against the which, a moiety competent Was gaged by our king, which had returned To the inheritance of Fortinbras, Had he been vanquisher, as, by the same cov'nant, And carriage of the article designed, His fell to Hamlet. Now, sir, young Fortinbras, Of unimprovèd mettle hot and full, Hath in the skirts of Norway here and there Sharked up a list of landless resolutes For food and diet to some enterprise That hath a stomach in't, which is no other - And it doth well appear unto our state - But to recover of us, by strong hand And terms compulsative, those foresaid lands So by his father lost: and this, I take it, Is the main motive of our preparations, The source of this our watch and the chief head Of this post-haste and rummage in the land."

func XORDecodeHex(block []byte, passChar byte) []byte {
	decoded, success := HexDecode(block)

	if !success {
		return []byte{}
	}

	buffer := make([]byte, len(decoded), len(decoded))

	for i := 0; i < len(decoded); i++ {
		buffer[i] = decoded[i] ^ passChar
	}

	return buffer
}

func XORDecodePlain(bytes []byte, passChar byte) []byte {
	buffer := make([]byte, len(bytes), len(bytes))

	for i := 0; i < len(bytes); i++ {
		buffer[i] = bytes[i] ^ passChar
	}

	return buffer
}

func FindCharacterFrequency(char byte) (freq int) {
	for i := 0; i < len(AlphabeticCharactersByFrequency); i++ {
		if AlphabeticCharactersByFrequency[i] == char {
			return i
		}
	}

	return 0
}

func ScoreTextByAlphabeticFrequency(text []byte) (score int) {
	for i := 0; i < len(text); i++ {
		score += FindCharacterFrequency(text[i])
	}

	return
}

func BruteForceXORSingleCharacterHexEncodedBlock(block []byte) (score int, key byte, result []byte) {

	bytes, _ := HexDecode(block)

	for i := 0; i < 256; i++ {
		decoded := XORDecodePlain(bytes, byte(i))
		decodedScore := ScoreTextByAlphabeticFrequency(decoded)

		if decodedScore > score {
			score = decodedScore
			key = byte(i)
			result = decoded
		}
	}

	return
}
